import { builtinCall } from "../ast/function.js";
const $bvec = (t) => ("bvec" + t[t.length - 1]);
const $call = (fn, a, b) => builtinCall(fn, $bvec(a.type), a, b);
export function lessThan(a, b) {
    return $call("lessThan", a, b);
}
export function lessThanEqual(a, b) {
    return $call("lessThanEqual", a, b);
}
export function greaterThan(a, b) {
    return $call("greaterThan", a, b);
}
export function greaterThanEqual(a, b) {
    return $call("greaterThanEqual", a, b);
}
export function equal(a, b) {
    return $call("equal", a, b);
}
export function notEqual(a, b) {
    return $call("notEqual", a, b);
}
export const _any = (v) => builtinCall("any", "bool", v);
export const all = (v) => builtinCall("all", "bool", v);
export const _not = (v) => builtinCall("not", v.type, v);
