import { DEFAULT, defmulti } from "@thi.ng/defmulti/defmulti";
import { unsupported } from "@thi.ng/errors/unsupported";
/**
 * Takes an object of code generator functions and returns a new code generator
 * / compile target function which serializes a given AST using the provided
 * node type implementations.
 *
 * [`targetGLSL()`](https://docs.thi.ng/umbrella/shader-ast-glsl/functions/targetGLSL.html)
 *
 * @param impls -
 */
export const defTarget = (impls) => defmulti((x) => x.tag, {}, {
    [DEFAULT]: (t) => unsupported(`no impl for AST node type: '${t.tag}'`),
    ...impls,
});
